module Jabysoft
  module AuthorisationService
    def authorise_link(action, model:, style:, options:)
      options.reverse_merge!(class: style)
      authorised = link_authorised?(action, model) if model.present?
      options.merge!(class: style + " disabled ") unless authorised
      return yield authorised
    end

    private
    def link_authorised?(action, model)
      return true if Jabysoft.configuration.authorisation_skipped?
      can? action, model
    end
  end
end